<%#-- copyright
OpenProject is an open source project management software.
Copyright (C) 2012-2023 the OpenProject GmbH

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License version 3.

OpenProject is a fork of ChiliProject, which is a fork of Redmine. The copyright follows:
Copyright (C) 2006-2013 Jean-Philippe Lang
Copyright (C) 2010-2013 the ChiliProject Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

See COPYRIGHT and LICENSE files for more details.

++#%>
<%= toolbar title: t(:label_project_plural) %>

<%= styled_form_tag(admin_settings_update_projects_path, method: :patch) do %>
  <section class="form--section">
    <fieldset class="form--fieldset">
      <legend class="form--fieldset-legend"><%= t('settings.projects.section_new_projects') %></legend>
      <div class="form--field"><%= setting_check_box :default_projects_public %></div>
      <div class="form--field">
        <%= setting_multiselect(:default_projects_modules,
          OpenProject::AccessControl.available_project_modules.collect {|m| [l_or_humanize(m, prefix: "project_module_"), m.to_s]}) %>
      </div>
      <div class="form--field"><%= setting_select :new_project_user_role_id,
                        Role.givable.collect {|r| [r.name, r.id.to_s]},
                        blank: "--- #{t(:actionview_instancetag_blank_option)} ---",
                        container_class: '-middle' %></div>
    </fieldset>
  </section>

  <section class="form--section">
    <fieldset class="form--fieldset">
      <legend class="form--fieldset-legend"><%= t('settings.projects.section_project_overview') %></legend>
      <%
        column_choices = ::Projects::TableComponent
          .new(current_user: current_user)
          .all_columns
          .reject { |_, options| !options[:caption] }
          .map { |name, options| [options[:caption], name.to_s, checked: options[:builtin], disabled: options[:builtin]] }
      %>
      
      <div class="form--field">
        <%= setting_multiselect(:enabled_projects_columns, column_choices) %>
      </div>

      <div class="form--field">
        <%= setting_block("project_gantt_query") do %>
        <span class="form--check-box-field-container -slim">
          <%= content_tag 'editable-query-props',
                          '',
                          data: {
                            name: 'settings[project_gantt_query]',
                            id: 'settings_project_gantt_query',
                            query: ::Projects::GanttQueryGeneratorService.current_query,
                            'url-params': 'true'
                          }
          %>
        </span>
        <% end %>
        <div class="form--field-instructions">
          <%= I18n.t(:setting_project_gantt_query_text) %>
        </div>
      </div>
    </fieldset>
  </section>

  <%= styled_button_tag t(:button_save), class: '-highlight -with-icon icon-checkmark' %>
<% end %>
